//
//  AppDelegate.m
//  Convertisseur
//
//  Created by philippe lacomme on 08/11/12.
//  Copyright (c) 2012 Philippe Lacomme. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate  
@synthesize webData, soapResults, xmlParser ;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}


-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    [webData setLength: 0];
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [webData appendData:data];
}

-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"ERROR with theConkenction");
     
    [connection release];
    [webData release];
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"DONE. Received Bytes: %d", [webData length]);
	
    if( xmlParser )
        [xmlParser release];
	
    xmlParser = [[NSXMLParser alloc] initWithData: webData];
    [xmlParser setDelegate: self];
    [xmlParser setShouldResolveExternalEntities: YES];
    [xmlParser parse];
	
    [connection release];
    [webData release];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName
 namespaceURI:(NSString *) namespaceURI qualifiedName:(NSString *)qName
   attributes: (NSDictionary *)attributeDict
{
    if( [elementName isEqualToString:@"ConversionRateResult"])
    {
        if(!soapResults)
            soapResults = [[NSMutableString alloc] init];
        _xmlResults = YES;
    }
}

-(void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    if( _xmlResults )
        [soapResults appendString: string];
}

-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
 namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    if( [elementName isEqualToString:@"ConversionRateResult"])
    {
        _xmlResults = FALSE;
        [_LaParite setStringValue:(NSString *)soapResults];
        [soapResults release];
        soapResults = nil;
    }
}


- (IBAction)GestionClic:(id)sender {
    NSString *monnaie_origine = [_LaMOrigine stringValue];
    NSString *monnaie_destination = [_LaMDestination stringValue];
    [_LaParite setStringValue:monnaie_origine];
    
    
    
    //líenveloppe SOAP
	NSString *soapMessage = [NSString stringWithFormat:
                             @"<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
                             "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
                             "<s:Body xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\n"
                             "<ConversionRate xmlns=\"http://www.webserviceX.NET/\">\n"
                             "<FromCurrency>%@</FromCurrency>\n"
                             "<ToCurrency>%@</ToCurrency>\n"
                             "</ConversionRate>\n"
                             "</s:Body>\n"
                             "</s:Envelope>\n", monnaie_origine, monnaie_destination];
	
	NSLog(soapMessage);
	NSURL *url = [NSURL URLWithString:@"http://www.webservicex.net/CurrencyConvertor.asmx"];
	NSMutableURLRequest *theRequest = [NSMutableURLRequest requestWithURL:url];
	NSString *msgLength = [NSString stringWithFormat:@"%d", [soapMessage length]];
	
	[theRequest addValue: @"text/xml; charset=utf-8;" forHTTPHeaderField:@"Content-Type"];
	[theRequest addValue: @"\"http://www.webserviceX.NET/ConversionRate\"" forHTTPHeaderField:@"SOAPAction"];
	[theRequest addValue: msgLength forHTTPHeaderField:@"Content-Length"];
	[theRequest setHTTPMethod:@"POST"];
	
	[theRequest setHTTPBody: [soapMessage dataUsingEncoding:NSUTF8StringEncoding]];
	NSURLConnection *theConnection = [[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	
	if( theConnection )
	{ 
        webData=[[NSMutableData data] retain];
    }
	else
	{
		NSLog(@"theConnection is NULL");
	}	
    

}


@end
